unit HiTempFont;

//HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Fonts
interface

uses Windows,Messages,kol,Share,Debug;

type
 THiTempFont = class(TDebug)
   private
     fFontFile:string;
     fFontName:string;
   public

    _prop_FileName:string;
    
    _data_FileName: THI_Event;
    _event_onInstall: THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doInstall(var _Data:TData; Index:word);
    procedure _var_FontName(var _Data:TData; Index:word);        
 end;
implementation

function StringToWideString(const s: String; codePage: Word): WideString;
var   len: integer;
begin
   Result := '';
   if s = '' then exit;
   len := MultiByteToWideChar(codePage, MB_PRECOMPOSED, PChar(@s[1]), -1, nil, 0);
   SetLength(Result, len - 1);
   if len <= 1 then exit;
   MultiByteToWideChar(CodePage, MB_PRECOMPOSED, PChar(@s[1]), -1, PWideChar(@Result[1]), len);
end;

function GetFontName (FontFileA : string) : String;
type
   TGetFontResourceInfoW = function (FontPath : PWideChar; var BufSize : DWORD; FontName : PWideChar; dwFlags : DWORD) : DWORD; stdcall;
var
      GetFontResourceInfoW : TGetFontResourceInfoW;
      FontFileW : PWideChar;
      FontNameW : PWideChar;
      FontNameSize : DWORD;

begin
   Result := '';
   GetFontResourceInfoW := GetProcAddress(GetModuleHandle('gdi32.dll'), 'GetFontResourceInfoW');
   if @GetFontResourceInfoW = nil then Exit;
   FontFileW := PWChar(StringToWideString(FontFileA,3));
   FontNameSize := 0;
   FontNameW := nil;
   GetFontResourceInfoW (FontFileW, FontNameSize, FontNameW, 1);
   GetMem (FontNameW, FontNameSize);
   FontNameW^ := #0; //   - 
   GetFontResourceInfoW (FontFileW, FontNameSize, FontNameW, 1);
   Result := FontNameW;
end;

constructor THiTempFont.Create;
begin
   inherited;
   fFontFile := '';
   fFontName := '';
end;

destructor THiTempFont.Destroy;
begin
   if fFontFile <> '' then begin
      RemoveFontResource(PChar(fFontFile));
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   end;
   inherited;
end;

procedure THiTempFont._work_doInstall;
var   s: string;
      len: dword;
      fn: pchar;
      sfnt:integer;
begin
   if fFontFile <> '' then begin
      RemoveFontResource(PChar(fFontFile));
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   end;   
   s := ReadString(_Data, _data_FileName, _prop_FileName);
   len := GetFullPathName(@s[1],0,nil,fn);
   setlength(fFontFile,len-1);
   GetFullPathName(@s[1], len, @fFontFile[1], fn);
   if not FileExists(fFontFile) then exit;
   sfnt := AddFontResource(PChar(fFontFile));
   if sfnt <> 0 then begin 
      fFontName := GetFontName(fFontFile);
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   end;   
   _hi_CreateEvent(_Data, @_event_onInstall, sfnt);
end;

procedure THiTempFont._var_FontName;
begin
   dtString(_Data, fFontName);
end;

end.